import java.awt.*;

abstract class MovingObj 
{
  // Variables
protected Rectangle zone;
protected boolean activeMove;
protected boolean inMove;
  // Constructors
public MovingObj(int x, int y, int w, int h, boolean am) {
  activeMove = am;
  inMove = false;
  zone = new Rectangle(x,y,w,h);
}
											  
  // Action methods
public void move(Graphics g, int dx, int dy) {
  if (activeMove) {
    g.copyArea(zone.x,zone.y,zone.width,zone.height,dx,dy);
    if (dx<0) {
      g.clearRect( zone.x+zone.width+dx, zone.y, -dx+1, zone.height+1);
      paintArea( g, zone.x+zone.width+dx, zone.y, -dx+1, zone.height+1);
    }
    if (dy<0) {
      g.clearRect( zone.x, zone.y+zone.height+dy, zone.width+1, -dy+1);
      paintArea( g, zone.x, zone.y+zone.height+dy, zone.width+1, -dy+1);
    }
    if (dx>0) {
      g.clearRect( zone.x, zone.y, dx+1, zone.height+1);
      paintArea( g, zone.x, zone.y, dx+1, zone.height+1);
    }
    if (dy>0) {
      g.clearRect( zone.x, zone.y, zone.width+1, dy+1);
      paintArea( g, zone.x, zone.y, zone.width+1, dy+1);
    }
  }

  //		inform(zone);
		
  zone.x += dx;
  zone.y += dy;
  if (activeMove) paint(g);
}

public void clear( Graphics g) {
  if(g==null || zone==null)
    {
      System.out.println("Problems with nulls");
      System.out.println(g);
      System.out.println(zone);
    }
  g.clearRect( zone.x, zone.y, zone.width+1, zone.height+1);
  paintArea( g, zone.x, zone.y, zone.width+1, zone.height+1);
}


public void moveTo(Graphics g, int x, int y) {
  move(g, x-zone.x, y-zone.y);
}

  abstract public void paint(Graphics g);
  abstract public void paintArea( Graphics g, int x, int y, int w, int h);

public boolean inform(Rectangle z) {
  return zone.intersects(z);		
}

  // Accessors
public Rectangle getZone() { return zone; }	

public void setInMove( boolean im) { inMove = im; }
public boolean isActive() { return activeMove; }
}
